/******************************************************************************/
/*          ______  ___   ______  ___   __________   ______                   */
/*          ___   |/  /   ___   |/  /   ___  ____/   __<  /                   */
/*          __  /|_/ /    __  /|_/ /    __  /_       __  /                    */
/*          _  /  / /     _  /  / /     _  __/       _  /                     */
/*          /_/  /_/      /_/  /_/      /_/          /_/                      */
/*                                                                (2010/2011) */
/******************************************************************************/
/*  Suma 1/n za prih N prirodnih brojeva racunata koristeci dvije ekvivalentne*/
/*  relacije:                                                                 */
/*     =  1/N + 1/(N-1) + ... + 1/2 + 1                                       */
/*     =  1 + 1/2 + ... + 1/(N-1) + 1/N                                       */
/*                                                                            */
/******************************************************************************/

#include<stdio.h>      // Deinirane standardne ulazno, izlazne funkcije
#include<stdlib.h>     // Deinirana nama potrebna funkcija za pauziranje

#define N 1000000

int main(void){
  long long i;
  float  sum11 = 0.,sum12 = 0., delta1;
  double sum21 = 0.,sum22 = 0., delta2;

  printf("sum_1 =  1 + 1/2 + ... + 1/(N-1) + 1/N\n");
  printf("sum_2 =  1/N + 1/(N-1) + ... + 1/2 + 1\n");
  printf("delta =  sum_2 - sum_1\n");
  printf("N = %d\n", N);
  printf("--------------------------------------\n\n");
  for(i=1;i<=N*N*N;i++){
    sum11 = sum11 + 1./(float)i;
    sum12 = sum12 + 1./(float)(N-i+1);
    sum21 = sum21 + 1./(double)i;
    sum22 = sum22 + 1./(double)(N-i+1);
  }
  delta1 = sum12 - sum11;
  delta2 = sum22 - sum21;
  printf("Float: \tsum11=%f  sum12=%f  delta=%f\n",  sum11, sum12,delta1);
  printf("Double:\tsum11=%f  sum12=%f  delta=%f\n", sum21, sum22,delta2);

  system("PAUSE");
  return 0;
}
